#pragma once

#include <memory>
#include <Arduino.h>
#include <ArduinoJson.h>

enum NM_HTML_ENUM_INPUT_TYPE { TEXT, PASS, NUM };

class NetworkManagerWebUI {
    public:
        /**
         * pageAPSettings will fill the given string with the html for the configuration page
         * @param p page string to build the page in
         * @param curApConf Current configuration to reflect in the html page
         */
        static void pageAPSettings(String &p, JsonDocument* curApConf);
        /**
         * pageSTASettings will fill the given string with the html for the configuration page
         * @param p page string to build the page in
         * @param curStaConf Current configuration to reflect in the html page
         */
        static void pageSTASettings(String &p, JsonDocument* curStaConf);

        /**
         * getHead inserts the start of the html document (including all the heading tags)
         * @param p page string to add to
         */
        static void getHead(String &p);
        /**
         * getHead inserts the start of the html document (including all the heading tags)
         * @param p page string to add to
         * @param title Title of the page (in the heading)
         */
        static void getHead(String &p, const char* title);
        /**
         * getBody inserts the start of the visible document (including a head and subheading)
         * @param p page string to add to
         * @param header header text
         * @param subHeader sub header text
         */
        static void getBody(String &p, const char* header, const char* subHeader);

        /**
         * getTail inserts the end of the html document (closing the body)
         * @param p page string to add to
         */
        static void getTail(String &p);

        /**
         * getFormStart inserts the start of a form segment
         * @param p page string to add to
         * @param action url the form sends to
         */
        static void getFormStart(String& p, const char* action);
        /**
         * getFormEnd inserts the end of a form segment
         * @param p page string to add to
         */
        static void getFormEnd(String &p);

        /**
         * getFormCheckBtn inserts a checkbox button combo element
         * @param p page string to add to
         * @param variable name of the variable / element
         * @param text label / button text
         * @param checked current value
         */
        static void getFormCheckBtn(String &p, const char* variable, const char* text, bool checked);

        /**
         * getFormInput inserts a regular input element
         * @param p page string to add to
         * @param variable name of the variable / element
         * @param label label text
         */
        static void getFormInput(String &p, const char* variable, const char* label);
        /**
         * getFormInput inserts a regular input element
         * @param p page string to add to
         * @param variable name of the variable / element
         * @param label label text
         * @param type type of the input
         */
        static void getFormInput(String &p, const char* variable, const char* label, NM_HTML_ENUM_INPUT_TYPE type);

        // static void getFormInput(String &p, const char* variable, const char* label, int value); // cannot use because of enum
        /**
         * getFormInput inserts a regular input element
         * @param p page string to add to
         * @param variable name of the variable / element
         * @param label label text
         * @param value current value
         * @param type type of the input
         */
        static void getFormInput(String &p, const char* variable, const char* label, int value, NM_HTML_ENUM_INPUT_TYPE type);
        /**
         * getFormInput inserts a regular input element
         * @param p page string to add to
         * @param variable name of the variable / element
         * @param label label text
         * @param value current value
         * @param note subtext / note
         * @param type type of the input
         */
        static void getFormInput(String &p, const char* variable, const char* label, int value, String note, NM_HTML_ENUM_INPUT_TYPE type);

        /**
         * getFormInput inserts a regular input element
         * @param p page string to add to
         * @param variable name of the variable / element
         * @param label label text
         * @param value current value
         */
        static void getFormInput(String &p, const char* variable, const char* label, const char* value);
        /**
         * getFormInput inserts a regular input element
         * @param p page string to add to
         * @param variable name of the variable / element
         * @param label label text
         * @param value current value
         * @param type type of the input
         */
        static void getFormInput(String &p, const char* variable, const char* label, const char* value, NM_HTML_ENUM_INPUT_TYPE type);
        /**
         * getFormInput inserts a regular input element
         * @param p page string to add to
         * @param variable name of the variable / element
         * @param label label text
         * @param value current value
         * @param note subtext / note
         * @param type type of the input
         */
        static void getFormInput(String &p, const char* variable, const char* label, const char* value, String note, NM_HTML_ENUM_INPUT_TYPE type);

        /**
         * getFormCollapseStart inserts a collapsable form segment (using a button)
         * @param p page string to add to
         * @param uid unique identifier of the field (alphanumeric only, not starting with a number)
         * @param label label / button text
         */
        static void getFormCollapseStart(String &p, const char* uid, const char* label);
        /**
         * getFormCollapseEnd inserts the end of a collapsable form segment
         * @param p page string to add to
         */
        static void getFormCollapseEnd(String &p);

        /**
         * getBtn inserts a button link element
         * @param p page string to add to
         * @param url URL to link to
         * @param label label text
         */
        static void getBtn(String &p, const char* url, const char* label);
        /**
         * getBtn inserts a button link element
         * @param p page string to add to
         * @param url URL to link to
         * @param label label text
         * @param id unique identifier for targeting by script, use "submit" to submit forms
         */
        static void getBtn(String &p, const char* url, const char* label, const char* id);

        /**
         * inputEnumToString inserts the textual representation of html input types
         * @param in Enum input type
         * @param s string to append the textual representation to
         */
        static void inputEnumToString(NM_HTML_ENUM_INPUT_TYPE in, String &s);
};

/** HTML templates **/

/**
 * page header
 * {a} = title
 */
const char NM_HTML_HEAD[] PROGMEM = "<!DOCTYPE html><html><head><meta charset=utf-8><meta name=viewport content=\"width=device-width,initial-scale=1,user-scalable=no\"><link rel=stylesheet href=/nm/style.css><script type=text/javascript src=/nm/script.js></script><title>{a}</title></head>";
/**
 * page body start
 * {a} = header
 * {b} = subheader
 */
const char NM_HTML_BODY[] PROGMEM = "<body><main><h1>{a}</h1><h2>{b}</h2>";
/**
 * Page end
 */
const char NM_HTML_END[] PROGMEM = "</main><div id=alert onclick=\"ald()\"></div></body><script type=text/javascript>const forms = document.querySelectorAll('form');for (const form of forms) {form.addEventListener('submit', sf);}</script></html>";

/**
 * Form start
 * {a} = action
 */
const char NM_HTML_FORM_START[] PROGMEM = "<form action=\"{a}\"><div class=b>";
/**
 * Form end
 */
const char NM_HTML_FORM_END[] PROGMEM = "</div></form>";

/**
 * Checkbox button
 * {a} = variable name
 * {b} = button text / name
 * {c} = value ("checked" or "")
 */
const char NM_HTML_FORM_CHECKBTN[] PROGMEM = "<label class=\"checkbox btn\"><span class=checkbox__input><input type=checkbox name={a} {c}/><span class=checkbox__control><svg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 24 24' aria-hidden=true focusable=false><path fill='none' stroke='currentColor' stroke-width='3' d='M1.73 12.91l6.37 6.37L22.79 4.59' /></svg></span></span><span class=radio__label>{b}</span></label>";
/**
 * Input
 * {a} = variable name
 * {b} = label
 * {c} = placeholder
 * {d} = Subscript note
 * {e} = value
 * {f} = type
 */
const char NM_HTML_FORM_INPUT[] PROGMEM = "<div class=fs><label for={a}>{b}</label><br/><input id={a} type={f} name={a} placeholder=\"{c}\" value=\"{e}\"/><br/><span>{d}</span></div>";

/**
 * Form collapse container
 * {a} = id
 * {b} = label
 */
const char NM_HTML_FORM_COLLAPSE_START[] PROGMEM = "<a class=\"btn btn2\" id={a}b onclick=\"ta('{a}s','{a}b');\">{b}</a><div id={a}s class=fc>";
/**
 * Form collapse container end
 */
const char NM_HTML_FORM_COLLAPSE_END[] PROGMEM = "</div>";

/**
 * Link Button
 * {a} = url
 * {b} = label
 * {c} = id
 */        
const char NM_HTML_BTN[] PROGMEM = "<a href=\"{a}\"><button id={c}>{b}</button></a>";

const unsigned char style_css_gz[] PROGMEM = {
    0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x03, 0x7d, 0x55,
    0x6d, 0x6f, 0x9b, 0x30, 0x10, 0xfe, 0x2b, 0xa8, 0xd1, 0xa4, 0x76, 0x0b,
    0xc8, 0xb0, 0x66, 0x6b, 0x8d, 0xb4, 0x2f, 0xfb, 0x21, 0x95, 0xc1, 0x07,
    0xb1, 0x0a, 0x36, 0xb2, 0x4d, 0x92, 0x0e, 0xf1, 0xdf, 0x77, 0x36, 0x26,
    0x6f, 0xd0, 0x7e, 0x08, 0x18, 0x9f, 0xef, 0xee, 0xb9, 0xe7, 0x39, 0x5f,
    0xa8, 0x56, 0xca, 0x0e, 0x71, 0x5c, 0xaa, 0x46, 0x69, 0x7a, 0xdc, 0x0b,
    0x0b, 0x63, 0xa1, 0xf8, 0xc7, 0xd0, 0x32, 0x5d, 0x0b, 0x49, 0x49, 0xde,
    0x31, 0xce, 0x85, 0xac, 0x71, 0xc5, 0x85, 0xe9, 0x1a, 0xf6, 0x41, 0xab,
    0x06, 0x4e, 0xb9, 0x7b, 0xc4, 0x5c, 0x68, 0x28, 0xad, 0x50, 0x92, 0x6a,
    0x75, 0xcc, 0x0b, 0x56, 0xbe, 0xd7, 0x5a, 0xf5, 0x92, 0x87, 0x70, 0x1b,
    0xce, 0x79, 0x1e, 0x96, 0x69, 0x9a, 0x8e, 0x2d, 0x13, 0x72, 0x70, 0x8e,
    0xf4, 0x85, 0x7c, 0x3b, 0x07, 0x4e, 0xa1, 0xcd, 0x2d, 0x9c, 0x6c, 0xcc,
    0x1a, 0x51, 0x4b, 0x5a, 0x82, 0xb4, 0xa0, 0xc7, 0xa4, 0xb0, 0x72, 0x5b,
    0xf4, 0xd6, 0x2a, 0x39, 0x1c, 0x05, 0xb7, 0x7b, 0xef, 0x13, 0x50, 0x25,
    0x19, 0xb4, 0x11, 0x89, 0x92, 0x1d, 0xba, 0xce, 0x61, 0x92, 0x17, 0xdc,
    0x4b, 0x9d, 0x25, 0xaf, 0x94, 0xb4, 0xb1, 0x11, 0xff, 0xc0, 0xc7, 0x0e,
    0x00, 0xaa, 0xaa, 0xba, 0x42, 0x48, 0x37, 0xe4, 0x05, 0xbf, 0x95, 0xe6,
    0xa0, 0xa9, 0x54, 0x12, 0xc2, 0x3a, 0xd6, 0x8c, 0x8b, 0xde, 0xd0, 0x5d,
    0x77, 0xca, 0xcb, 0x5e, 0x1b, 0xf4, 0xec, 0x94, 0x38, 0x23, 0x1a, 0x66,
    0x0e, 0x84, 0x6c, 0x84, 0x84, 0xb8, 0x68, 0x54, 0xf9, 0x9e, 0x4f, 0xf8,
    0x84, 0x14, 0x56, 0xb0, 0x66, 0xc6, 0x48, 0xc6, 0x09, 0x3d, 0x45, 0x17,
    0x56, 0x34, 0xc0, 0x87, 0x00, 0x04, 0x00, 0x6e, 0x80, 0x14, 0xbc, 0x9a,
    0x53, 0x85, 0x10, 0x3e, 0x55, 0x36, 0x2c, 0xf9, 0x24, 0xcf, 0x95, 0xb7,
    0xfd, 0x5c, 0xb3, 0x15, 0x64, 0xf2, 0x4b, 0x0c, 0x34, 0x6b, 0xf6, 0x8c,
    0x8f, 0x42, 0x76, 0xbd, 0x5d, 0xd0, 0x19, 0x5b, 0xd5, 0x79, 0x4a, 0x2f,
    0x5c, 0x66, 0xc8, 0xec, 0x44, 0xef, 0x2a, 0x97, 0x84, 0x90, 0x15, 0xb5,
    0x3d, 0xc3, 0x13, 0xa3, 0x69, 0x77, 0x8a, 0x8c, 0x6a, 0x04, 0x8f, 0x36,
    0xaf, 0xaf, 0xaf, 0x77, 0xdc, 0x3e, 0x23, 0xb7, 0xaa, 0xb7, 0x8e, 0x40,
    0x64, 0xc9, 0x63, 0xa2, 0x95, 0x2a, 0x7b, 0x33, 0x2c, 0xbd, 0x51, 0x25,
    0xac, 0x6a, 0xb8, 0xea, 0x95, 0x31, 0xa9, 0xcc, 0x70, 0x05, 0x3c, 0xf5,
    0x30, 0xc3, 0x46, 0xa1, 0x90, 0xf2, 0x96, 0x26, 0xbf, 0xa7, 0x73, 0x91,
    0xe9, 0x18, 0x76, 0xdc, 0xb9, 0x04, 0xd7, 0x23, 0xb8, 0x5f, 0x2e, 0xfd,
    0x67, 0x5d, 0x5d, 0x2b, 0x8c, 0x9b, 0x7e, 0xb8, 0xf9, 0x4e, 0xca, 0x3d,
    0x94, 0xef, 0x85, 0x3a, 0xdd, 0xcb, 0x5f, 0x6b, 0xc1, 0x73, 0xf7, 0x88,
    0x2d, 0xb4, 0x68, 0xb0, 0xe0, 0xb8, 0xe8, 0x5b, 0x69, 0x68, 0x8b, 0xe1,
    0x4b, 0x4c, 0x8c, 0xdd, 0x1c, 0xb1, 0xde, 0xaa, 0xe9, 0x58, 0xcd, 0x90,
    0xe9, 0xdd, 0x99, 0xc8, 0x03, 0xd3, 0x8f, 0xe1, 0xee, 0x3d, 0x5d, 0xb2,
    0xbc, 0xbd, 0x79, 0x4e, 0xa2, 0x49, 0x2d, 0xd5, 0xb1, 0x52, 0xd8, 0x0f,
    0xbc, 0x7f, 0x93, 0x6e, 0x4e, 0x86, 0x3d, 0x88, 0x7a, 0x6f, 0x27, 0x45,
    0xee, 0x9a, 0xf4, 0x12, 0xc4, 0x65, 0xd7, 0xaa, 0x59, 0xc5, 0xbc, 0x1a,
    0xea, 0x56, 0x25, 0xdf, 0x03, 0xb3, 0x9e, 0x09, 0xda, 0x83, 0x24, 0x98,
    0x50, 0x63, 0x51, 0x7f, 0x1d, 0xe8, 0x05, 0xe6, 0x73, 0xb2, 0x15, 0x66,
    0x98, 0x06, 0x66, 0xe8, 0xc3, 0xec, 0xf1, 0xb0, 0x70, 0xfe, 0xf3, 0x7d,
    0xf0, 0x1e, 0xee, 0x20, 0x9d, 0x6d, 0x2b, 0x15, 0x45, 0xe6, 0x50, 0x0f,
    0x56, 0x33, 0x69, 0x84, 0x9f, 0x3d, 0x7e, 0x59, 0x29, 0x8d, 0x1d, 0x9b,
    0x9a, 0x08, 0x93, 0x40, 0x2c, 0x64, 0x94, 0xed, 0x5a, 0x93, 0x9f, 0x4d,
    0xd4, 0x94, 0xac, 0x81, 0x47, 0xf2, 0x74, 0xd9, 0x8a, 0x95, 0x16, 0xee,
    0xa2, 0x4e, 0x3d, 0x13, 0x35, 0x50, 0xd9, 0x4f, 0x34, 0x98, 0xc0, 0x00,
    0xff, 0xf1, 0x15, 0x96, 0xab, 0x2c, 0xe9, 0xd3, 0xb8, 0xc1, 0xb7, 0xb6,
    0x43, 0xa7, 0x02, 0x46, 0x56, 0x20, 0x7b, 0xbd, 0x75, 0x63, 0xc6, 0x77,
    0x28, 0xc9, 0x5d, 0xbe, 0x8b, 0xa8, 0x04, 0x6f, 0x63, 0x90, 0x82, 0xe4,
    0x57, 0xb5, 0x4d, 0x7b, 0x51, 0x92, 0x4d, 0x85, 0x6d, 0xef, 0x6f, 0x5d,
    0x44, 0x42, 0xc5, 0x78, 0xa1, 0xdc, 0xa9, 0xeb, 0xfb, 0xea, 0x1b, 0xcd,
    0x6b, 0x1e, 0x22, 0x67, 0xae, 0xff, 0x97, 0xb3, 0xf6, 0x7a, 0x42, 0xaa,
    0x03, 0xe8, 0xaa, 0x51, 0x47, 0xba, 0x17, 0x9c, 0x83, 0x0c, 0x75, 0x24,
    0xb5, 0x06, 0x90, 0xcb, 0xa1, 0xa2, 0xeb, 0x82, 0x3d, 0x66, 0x64, 0x9b,
    0x11, 0xf7, 0xdb, 0x26, 0xbf, 0xe6, 0xc2, 0x13, 0x8d, 0xf3, 0xee, 0xb3,
    0xe3, 0xfe, 0xec, 0xed, 0xf1, 0x83, 0x30, 0x02, 0x67, 0xe4, 0xf0, 0x79,
    0xe5, 0xf9, 0x4d, 0x0d, 0x28, 0x41, 0x6c, 0xf6, 0x8c, 0x23, 0x50, 0x82,
    0x7f, 0x04, 0x29, 0x8e, 0x6b, 0x7c, 0x6d, 0x76, 0xbb, 0xdd, 0xf8, 0x1f,
    0xea, 0xc9, 0x77, 0x73, 0xd2, 0x06, 0x00, 0x00};
const unsigned int style_css_gz_len = 728;

const unsigned char script_js_gz[] PROGMEM = {
    0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x03, 0x9d, 0x93,
    0x51, 0x6f, 0xd3, 0x30, 0x10, 0xc7, 0xbf, 0x4a, 0xea, 0x87, 0xca, 0x96,
    0x82, 0xc9, 0x2a, 0xf1, 0xb0, 0x16, 0xaf, 0x1a, 0x6c, 0xa8, 0xa0, 0x8d,
    0x22, 0xda, 0x07, 0x24, 0xc4, 0xc3, 0xc5, 0xbe, 0x84, 0x6c, 0x8e, 0x1d,
    0x6c, 0xa7, 0x23, 0xaa, 0xfa, 0xdd, 0x71, 0x42, 0x5b, 0x6d, 0x40, 0x1f,
    0xc6, 0x53, 0x2e, 0x77, 0xff, 0xbb, 0xfb, 0xdd, 0xd9, 0x2e, 0x5a, 0x23,
    0x43, 0x65, 0x4d, 0x12, 0x80, 0x42, 0x9a, 0xb3, 0x2d, 0x0a, 0x65, 0x65,
    0x5b, 0xa3, 0x09, 0xbc, 0xc4, 0x70, 0xad, 0xb1, 0x37, 0xdf, 0x74, 0xef,
    0x15, 0x05, 0xc6, 0x7d, 0xe8, 0x34, 0xa6, 0xc5, 0x49, 0x49, 0xce, 0x52,
    0x92, 0x6b, 0x2b, 0xef, 0x89, 0x10, 0xc8, 0x55, 0xe5, 0x1b, 0x0d, 0xdd,
    0x9c, 0x1e, 0x4d, 0x41, 0x8c, 0x35, 0x48, 0xd2, 0x82, 0x4b, 0x0d, 0xde,
    0xdf, 0x54, 0x3e, 0x70, 0x87, 0xb5, 0xdd, 0x20, 0x25, 0x1e, 0x35, 0x61,
    0x6c, 0xfa, 0x58, 0xfc, 0xbb, 0xd4, 0x13, 0x35, 0x28, 0x75, 0x90, 0xee,
    0x8a, 0x03, 0xbb, 0x2f, 0x22, 0xdc, 0x16, 0x78, 0xe3, 0x70, 0x13, 0x51,
    0xae, 0xb0, 0x80, 0x56, 0x07, 0xca, 0x66, 0xd2, 0x1a, 0x1f, 0x92, 0x5c,
    0x18, 0x7c, 0x48, 0xde, 0x59, 0x57, 0x5f, 0x41, 0x3f, 0x26, 0x0f, 0xe0,
    0x22, 0x38, 0x4b, 0xa5, 0x58, 0xe6, 0x77, 0x28, 0x03, 0x2f, 0x9c, 0xad,
    0xaf, 0x4d, 0x70, 0x15, 0x7a, 0x9a, 0x73, 0xdc, 0x5b, 0x8c, 0xcd, 0x0a,
    0xeb, 0xe8, 0x06, 0x5c, 0xa2, 0x12, 0x5b, 0x24, 0xc7, 0x44, 0x22, 0xbf,
    0xa3, 0xbc, 0xcf, 0xed, 0xcf, 0x38, 0xa6, 0xe2, 0xa1, 0x6b, 0x70, 0x3c,
    0xa6, 0xf2, 0xab, 0xe2, 0x06, 0x6a, 0xfc, 0x16, 0x5d, 0x43, 0x1c, 0xd5,
    0x01, 0xa0, 0x1c, 0x00, 0xbe, 0xdc, 0xde, 0x2c, 0x42, 0x68, 0x3e, 0xe3,
    0x8f, 0x16, 0x7d, 0x98, 0x95, 0xdc, 0x36, 0x68, 0x28, 0xf9, 0xb4, 0x5c,
    0xad, 0x49, 0x7a, 0xa8, 0xcd, 0x61, 0x18, 0x89, 0xa5, 0x25, 0xf7, 0x18,
    0xf6, 0xda, 0x05, 0x82, 0x42, 0x47, 0xc9, 0x5b, 0x6b, 0x42, 0x84, 0x7b,
    0xb1, 0x8e, 0x1d, 0x49, 0x4a, 0xa0, 0x69, 0x74, 0x25, 0xa1, 0xd7, 0xbf,
    0xbc, 0xf3, 0xd6, 0x90, 0x7f, 0x67, 0x5d, 0x4a, 0x89, 0x4d, 0x38, 0xa5,
    0xb7, 0x46, 0x5b, 0x50, 0x02, 0xc4, 0xc5, 0xf6, 0xd4, 0xa9, 0x12, 0xdf,
    0xe6, 0x75, 0x15, 0x08, 0xeb, 0x4f, 0x06, 0x72, 0x8d, 0x4a, 0x8c, 0xce,
    0xd2, 0x49, 0x96, 0xbd, 0x16, 0x47, 0x6c, 0x1f, 0x20, 0xb4, 0x7e, 0x3c,
    0x9e, 0x9c, 0x9f, 0x5f, 0xfc, 0xe9, 0x9d, 0x83, 0xa6, 0x64, 0x05, 0x1b,
    0x54, 0x89, 0x6f, 0x23, 0x8c, 0xf7, 0x45, 0xab, 0x75, 0x37, 0x22, 0xe9,
    0x28, 0x63, 0xd3, 0x3e, 0x78, 0x69, 0x12, 0x74, 0xce, 0xba, 0xc4, 0x4a,
    0xd9, 0x3a, 0x87, 0xaa, 0x8f, 0x9d, 0xb1, 0xdd, 0xc0, 0x37, 0x44, 0x04,
    0x65, 0xcf, 0x26, 0x3c, 0x51, 0x39, 0x96, 0x7d, 0x4e, 0x9d, 0x6c, 0x58,
    0xaa, 0x51, 0xf4, 0xc3, 0x6a, 0xf9, 0x31, 0x4e, 0xe4, 0x2a, 0x53, 0x56,
    0x45, 0x47, 0xe5, 0xe3, 0x1b, 0x18, 0x5b, 0x0d, 0xaf, 0x07, 0x34, 0xba,
    0x70, 0xf2, 0x79, 0x90, 0x21, 0x1c, 0xd7, 0x3e, 0x7c, 0x79, 0x65, 0xe2,
    0x6c, 0x8b, 0xf5, 0xed, 0x8d, 0x80, 0x74, 0xb8, 0xe1, 0xe8, 0x45, 0x3e,
    0x27, 0x9b, 0xca, 0x57, 0xb1, 0x75, 0x52, 0x3a, 0x44, 0x43, 0xa6, 0xc7,
    0xff, 0x08, 0x4f, 0xf6, 0x99, 0xc7, 0xf7, 0x20, 0xf6, 0x79, 0x69, 0x3c,
    0xf6, 0x75, 0x55, 0xa3, 0x6d, 0x03, 0x1d, 0x36, 0x05, 0x5a, 0xd1, 0x38,
    0xe8, 0xe4, 0x55, 0x96, 0x3d, 0xc1, 0x8c, 0xde, 0xff, 0x85, 0x24, 0x7f,
    0x77, 0x27, 0x64, 0xf7, 0x0b, 0xb3, 0x35, 0xf1, 0x8d, 0x41, 0x04, 0x00,
    0x00};
const unsigned int script_js_gz_len = 529;